/* Include files */
#include "rz_dpsk_lockheed_ssmf_dcf_sfun.h"
#include "c1_rz_dpsk_lockheed_ssmf_dcf.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "rz_dpsk_lockheed_ssmf_dcf_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_rz_dpsk_lockheed_ssmf_dcfInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_rz_dpsk_lockheed_ssmf_dcf(void);
static void enable_c1_rz_dpsk_lockheed_ssmf_dcf(void);
static void disable_c1_rz_dpsk_lockheed_ssmf_dcf(void);
static void finalize_c1_rz_dpsk_lockheed_ssmf_dcf(void);
static void sf_c1_rz_dpsk_lockheed_ssmf_dcf(void);

/* Function Definitions */
static void initialize_c1_rz_dpsk_lockheed_ssmf_dcf(void)
{
  chartInstance.c1_is_active_c1_rz_dpsk_lockheed_ssmf_dcf = 0;
}

static void enable_c1_rz_dpsk_lockheed_ssmf_dcf(void)
{
}

static void disable_c1_rz_dpsk_lockheed_ssmf_dcf(void)
{
}

static void finalize_c1_rz_dpsk_lockheed_ssmf_dcf(void)
{
}

static void sf_c1_rz_dpsk_lockheed_ssmf_dcf(void)
{
  uint8_T c1_previousEvent;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  sf_debug_push_symbol_scope(0);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,5);
  sf_mex_call("errordlg", 0U, 1U, 15,
   "The signal input power to the EDFA is lower than the minimum threshold power");
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-5);
  sf_debug_pop_symbol_scope();
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
}

/* SFunction Glue Code */
void sf_c1_rz_dpsk_lockheed_ssmf_dcf_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3475106057U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2454476720U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2693013834U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(818057607U);
}

mxArray *sf_c1_rz_dpsk_lockheed_ssmf_dcf_get_autoinheritance_info(void)
{
  const char *autoinheritanceInfoStructFieldNames[] =
  {"checksum","inputTypes","outputSizes","outputTypes"};
  mxArray *mxAutoinheritanceInfo = NULL;
  mxArray *mxChecksum = NULL;
  mxArray *mxInputTypes = NULL;
  mxArray *mxOutputSizes = NULL;
  mxArray *mxOutputTypes = NULL;

  mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,
   sizeof(autoinheritanceInfoStructFieldNames)/sizeof(char *),
   autoinheritanceInfoStructFieldNames);

  mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
  ((real_T *)mxGetPr((mxChecksum)))[0] = (real_T)(2270858060U);
  ((real_T *)mxGetPr((mxChecksum)))[1] = (real_T)(3943251113U);
  ((real_T *)mxGetPr((mxChecksum)))[2] = (real_T)(3234102789U);
  ((real_T *)mxGetPr((mxChecksum)))[3] = (real_T)(505375474U);

  mxInputTypes = mxCreateDoubleMatrix(1,0,mxREAL);

  mxOutputSizes = mxCreateDoubleMatrix(2,0,mxREAL);
  mxOutputTypes = mxCreateDoubleMatrix(1,0,mxREAL);

  mxSetFieldByNumber(mxAutoinheritanceInfo,0,0,mxChecksum);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,1,mxInputTypes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,2,mxOutputSizes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,3,mxOutputTypes);

  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S)
{
  if(ssIsFirstInitCond(S)) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_rz_dpsk_lockheed_ssmf_dcfMachineNumber_,
         1,
         1,
         1,
         0,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_rz_dpsk_lockheed_ssmf_dcfMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_rz_dpsk_lockheed_ssmf_dcfMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,226);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_rz_dpsk_lockheed_ssmf_dcfMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c1_rz_dpsk_lockheed_ssmf_dcf(void
 *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S);
  initialize_c1_rz_dpsk_lockheed_ssmf_dcf();
}

static void sf_opaque_enable_c1_rz_dpsk_lockheed_ssmf_dcf(void *chartInstanceVar)
{
  enable_c1_rz_dpsk_lockheed_ssmf_dcf();
}

static void sf_opaque_disable_c1_rz_dpsk_lockheed_ssmf_dcf(void
 *chartInstanceVar)
{
  disable_c1_rz_dpsk_lockheed_ssmf_dcf();
}

static void sf_opaque_gateway_c1_rz_dpsk_lockheed_ssmf_dcf(void
 *chartInstanceVar)
{
  sf_c1_rz_dpsk_lockheed_ssmf_dcf();
}

static void sf_opaque_terminate_c1_rz_dpsk_lockheed_ssmf_dcf(void
 *chartInstanceVar)
{
  finalize_c1_rz_dpsk_lockheed_ssmf_dcf();
}

static void mdlSetWorkWidths_c1_rz_dpsk_lockheed_ssmf_dcf(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("rz_dpsk_lockheed_ssmf_dcf",1);
    int_T chartIsMultiInstanced =
      (int_T)sf_is_chart_multi_instanced("rz_dpsk_lockheed_ssmf_dcf",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    if(chartIsInlinable) {
    }
    if (!sf_is_chart_instance_optimized_out("rz_dpsk_lockheed_ssmf_dcf",1)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("rz_dpsk_lockheed_ssmf_dcf",1);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3475106057U));
  ssSetChecksum1(S,(2454476720U));
  ssSetChecksum2(S,(2693013834U));
  ssSetChecksum3(S,(818057607U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_rz_dpsk_lockheed_ssmf_dcf(SimStruct *S)
{
  sf_write_symbol_mapping(S, "rz_dpsk_lockheed_ssmf_dcf", 1);
  ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
}

static void mdlStart_c1_rz_dpsk_lockheed_ssmf_dcf(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.enableChart =
    sf_opaque_enable_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c1_rz_dpsk_lockheed_ssmf_dcf;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */
}

void c1_rz_dpsk_lockheed_ssmf_dcf_method_dispatcher(SimStruct *S, int_T method,
 void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_rz_dpsk_lockheed_ssmf_dcf(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_rz_dpsk_lockheed_ssmf_dcf(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c1_rz_dpsk_lockheed_ssmf_dcf_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

